* *******************************************************************
* SUORTEP IS A PROGRAM TO CREATE A FILE TO BE USED WITH
* THE ORTEP OPTION OF THE 2/90 VERSION OF GRAFIT WRITTEN
* BY R. S. ZHOU
* SUORTEP WAS WRITTEN BY DAVID P. MATHEIS 3/1/90
* INCORPORATING CRYSET WRITTEN BY ALAN LARSON TO GENERATE
* THE SYMMETRY CARDS NEEDED BY ORTEP
* *******************************************************************
*
      CHARACTER ONAME*75,  LABEL*12, ICENT*1, ICORN*1, ALABEL(100)*8
      CHARACTER OK*1, ASPGC(20)*1, LATRAN*60, BNAME*75
      DATA BLK/4H    /
      REAL*16 OPR(108), XOPR(3,192), LAUE(14)
      REAL*8 RADI(100), XX(100), YY(100), ZZ(100), RADII(100)
      INTEGER EXOR, NATOMS, NELEM(50), ICOL(10), NELE(100), INELEM(50)
      INTEGER IANION(50), ICATION(50)
      COMMON/CRYDAT/ NJ(2),L,X(192,9),XCT,KXB,NCTR(192)
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
      COMMON/CNTRLS/ JC(22)
      COMMON/HKLCTL/ KH(3,24),DHKL(24),KHCO(10,7),IC,N1,IER,HM
      COMMON/EXTINC/ IHKL(9,5,11),IEXTFG(13)
      DIMENSION KD(24),IDH(3,24)
      DIMENSION HF(8),HFX(3,24),IDEL(3,24)
      DIMENSION XC(2),CEN(2)
      DIMENSION IX1(192),IY1(192),IZ1(192)
      DIMENSION SYMB(20)
      DATA HF/4H  H,,4H  K,,4H -I,,4H  L,,4H -L,,4H  I,,4H -K,,4H -H,/
      DATA E/4HE   /
      DATA OPR/ 14HERROR         ,14H-1  1  0  0.00,14H 1  0  0  0.00,
     114H 0  1  0  0.00,14H 0  0  1  0.00,14HERROR         ,
     214HERROR         ,14HERROR         ,14HERROR         ,
     314HERROR         ,14HERROR         ,14HERROR       11,
     414HERROR       12,14HERROR       13,14H 0  0 -1  0.17,
     514HERROR       15,14HERROR       16,14HERROR       17, 
     614HERROR       18,14HERORR       19,14HERROR       20,
     714HERROR       21,14H 0  0  1  0.17,14H 0  0 -1  0.25,
     814H 0 -1  0  0.25,14H-1  0  0  0.25,14HERROR       26,
     914HERROR       27,14HERROR       28,14H 1  0  0  0.25,
     914H 0  1  0  0.25,14H 0  0  1  0.25,14H 0  0 -1  0.33,
     914H 0 -1  0  0.33,14H-1  0  0  0.33,14H 1 -1  0  0.33,
     914HERROR       36,14H-1  1  0  0.33,14H 1  0  0  0.33,
     914H 0  1  0  0.33,14H 0  0  1  0.33,14HERROR       41,
     914HERROR       42,14HERROR       43,14HERROR       44,
     914HERROR       45,14HERROR       46,14HERROR       47,
     914HERROR       48,14HERROR       49,14H 0  0 -1  0.50,
     914H 0 -1  0  0.50,14H-1  0  0  0.50,14HERROR       53,
     914HERROR       54,14HERROR       55,14H 1  0  0  0.50,
     914H 0  1  0  0.50,14H 0  0  1  0.50,14HERROR       59,
     914HERROR       60,14HERROR       61,14HERROR       62,
     914HERROR       63,14HERROR       64,14HERROR       65,
     914HERROR       66,14HERROR       67,14H 0  0 -1  0.67,
     914H 0 -1  0  0.67,14H-1  0  0  0.67,14H 1 -1  0  0.67,
     914HERROR       72,14H-1  1  0  0.67,14H 1  0  0  0.67,
     914H 0  1  0  0.67,14H 0  0  1  0.67,14H 0  0 -1  0.75,
     914H 0 -1  0  0.75,14H-1  0  0  0.75,14HERROR       80,
     914HERROR       81,14HERROR       82,14H 1  0  0  0.75,
     914H 0  1  0  0.75,14H 0  0  1  0.75,14H 0  0 -1  0.83,
     914HERROR       87,14HERROR       88,14HERROR       89,
     914HERROR       90,14HERROR       91,14HERROR       92,
     914HERROR       93,14H 0  0  1  0.83,14HERROR       95,
     914HERROR       96,14HERROR       97,14HERROR       98,
     914HERROR       99,14HERROR      100,14HERROR      101,
     914HERROR      102,14HERROR      103,14H 0  0 -1  0.00,
     914H 0 -1  0  0.00,14H-1  0  0  0.00,14H 1 -1  0  0.00/
      DATA JC/22*0/
      DATA XC/1H ,1HA/
      DATA CEN/1HC,1HA/
      DATA LAUE/8H1BAR    ,8H2/M     ,8HMMM     ,
     18H4/M     ,8H4/MMM   ,8H3BAR R  ,
     28H3BAR M R,8H3BAR    ,8H3BAR M 1,
     38H3BAR 1 M,8H6/M     ,8H6/MMM   ,
     48HM3      ,8HM3M     /
*      PRINT 532,OPR
* 532   FORMAT(108A16)
*
* WRITE THE PROGRAM SALUTATION
*
      WRITE(6,40)
 40    FORMAT(' Welcome to SUORTEP!!'/
     1' This program generates a file to be used in the'/
     2' ORTEP option of R. S. Zhous 2/90 verion of GRAFIT.'/
     3' Further information on the use of ORTEP can be found'/
     4' in the ORTEP manual, ORTEP:An Attempt at Limited Frustration'/
     5' by David Matheis'/
     6' ')
*
* GET THE OUTPUT FILE NAME
*
 400  WRITE(6,1)
 1      FORMAT(' Enter the output filename. <.TEP>')
      READ(6,2,ERR=400)ONAME
 2      FORMAT(A75)
      WRITE(6,50)
 50     FORMAT(' If you wish a file set up to calculate bond distances'/
     1' then enter another file name here <.TEP>.'/
     2' If not then enter a return.')
      READ(6,2)BNAME
*
* OPEN THE OUTPUT FILE
*
      OPEN(UNIT=10, FILE=ONAME, DEFAULTFILE='.TEP', STATUS='NEW', 
     1FORM='FORMATTED', CARRIAGECONTROL='LIST')
*
      IF(BNAME.NE.' ')THEN
        OPEN(UNIT=11, FILE=BNAME, DEFAULTFILE='.TEP', STATUS='NEW', 
     1FORM='FORMATTED', CARRIAGECONTROL='LIST')
      ENDIF
*
* GET THE INPUT HEADER INFORMATION
*
 401  WRITE(6,3)
 3      FORMAT(' Enter the chemical formula of the material'/
     1' (This is a label for the file)')
      READ(6,4,ERR=401)LABEL
 402  WRITE(6,5)
 5      FORMAT(' Enter the space group number of the material'/
     1' (This is a label for the file)')
      READ(6,6,ERR=402)NSG
 4      FORMAT(A)
 6      FORMAT(A3)
*
* WRITE THE ORTEP FILE HEADER
*
      WRITE(10,7)LABEL,NSG
 7      FORMAT(' =========== CRYSTAL STRUCTURE OF ',A,
     1' (space group#',A3,') =======')
      WRITE(10,8)BLK
 8      FORMAT(A4)
*
      IF(BNAME.NE.' ')THEN
        WRITE(11,7)LABEL,NAG
        WRITE(11,8)BLK
      ENDIF
*
* GET THE LATTICE PARAMETERS AND THEN INTERPRET THE 
* DEFAULT INPUTS
*
 403  WRITE(6,9)
 9      FORMAT(' Enter the lattice parameters.')
      READ(6,10,ERR=403)A,B,C,AA,BB,GG
 10     FORMAT(6F8.4) 
      IF(GG.EQ.0.0)THEN
        GG=90.0
      ENDIF
      IF(AA.NE.0.0.AND.BB.EQ.0.0)THEN
        IF(AA.EQ.120.0)THEN
          GG=AA
          AA=90.0
          GO TO 702
        ENDIF
 702    BB=AA
        AA=90.0
      ENDIF
      IF(BB.EQ.0.0)THEN
        BB=90.0
      ENDIF
      IF(AA.EQ.0.0)THEN
        AA=90.0
      ENDIF
      IF(C.EQ.0.0.AND.B.NE.0.0)THEN
        C=B
        B=A
      ENDIF
      IF(C.EQ.0.0.AND.B.EQ.0.0)THEN
        C=A
        B=A
      ENDIF
*
* WRITE THE LATTICE PARAMETERS TO THE ORTEP FILE
*
      WRITE(10,11)A,B,C,AA,BB,GG
 11    FORMAT(1XF7.4,2X,F7.4,2X,F7.4,2X,F7.2,2X,F7.2,2X,F7.2'  0')
       WRITE(10,8)BLK
*
      IF(BNAME.NE.' ')THEN
        WRITE(11,11)A,B,C,AA,BB,GG
        WRITE(11,8)BLK
      ENDIF
*
* USE CRYSET TO GENERATE SYMMETRY CARDS
* 
       JC(1)=1
       JC(2)=1
       JC(5) = 0
*
C  GET THE SPACE GROUP CODE
100   WRITE(6,12)
12    FORMAT(/' Now you must enter the Space group symbol (or E',
     1' to exit)'//' Syntax for space group symbol:'/
     2' The symbol is entered with spaces separating the operators'/
     3' The space group symbol consists of 4 operator fields'/
     4' The first contains the Bravais lattice operator(P, A, B, C, F,',
     5' I or R)'/' The next three contain rotation and translation',
     6' operators written as follows:'/' 1, 1BAR or -1, 2, 21, 2/M, ',
     7'2/A, 2/B, 2/C, 2/N, 3, 3BAR or -3, 31, 32,',/
     8' 4, 41, 42, 43, 4BAR or -4, 4/M, 4/N, 6, 61, 62, 63, 64, 65,',
     9' 6BAR or -6, 6/M, 63/M,'/' 42/N, 42/M, A, B, C, D, N, M, ETC.'/
     a' (For R-type lattices another operator(R)',
     A' is placed after the',
     b' symbol to define the'/' rhombohedral setting, otherwise the',
     c' hexagonal setting is taken by default).'//
     d' Each operator field is terminated with a space.'/
     E' Some examples are: P N M A        P 63/M M C'/
     f' P 21/C               b-axis unique monoclinic'/
     g' P 21/C 1 1           a-axis unique monoclinic'/
     h' P 1 1 2/N            c-axis unique monoclinic'/
     i' R 3BAR M R           Rhombohedral setting'/
     j' R 3BAR M             Hexagonal setting'//
     k'$Enter the Space Group Symbol: ')
      READ(5,13,ERR=100) (SPGC(I),I=1,20)
 13     FORMAT (20A1)
      IF ( SPGC(1).EQ.E ) STOP
*
* DETERMINE CELL TYPE AND DEFINE LATTICE TRANSLATIONS
*
* PRIMITIVE CELL
*
      IF(SPGC(1).EQ.4.4072286E-20)THEN
        JC(2) = 1
        JC(22) = 0
      ELSE
        JC(2) = 0
        JC(22) = 1
* FACE CENTERED CELL
        IF(SPGC(1).EQ.4.1954704E-20)THEN
          LATRAN = '0.5  0.5  0.0   0.5  0.0  0.5   0.0  0.5  0.5'
        ENDIF
* BODY CENTERED CELL
        IF(SPGC(1).EQ.4.2589979E-20)THEN
          LATRAN = '0.5  0.5  0.5'
        ENDIF
* A CENTERED CELL
        IF(SPGC(1).EQ.4.0895913E-20)THEN
          LATRAN = '0.0  0.5  0.5'
        ENDIF
* B CENTERED CELL
        IF(SPGC(1).EQ.4.2589979E-20)THEN
          LATRAN = '0.5  0.0  0.5'
        ENDIF
* C CENTERED CELL
        IF(SPGC(1).EQ.4.2589979E-20)THEN
          LATRAN = '0.5  0.5  0.0'
        ENDIF
      ENDIF
C
C  CALL SPGP TO GENERATE OPERATORS
      DO 105 I=1,20
  105 SYMB(I) = SPGC(I)
*      PRINT*,(SYMB(I),I=1,20
      CALL SPGP
      IF ( NSP(2).EQ.4 ) GO TO 100
      DO 110 I=1,20
      IF ( SPGC(I).NE.BLK ) GO TO 111
  110 CONTINUE
  111 SLAT = SPGC(I)
C
C  GIVE LATTICE TYPE AND SYMMETRY
      CALL OP1
      IF(NC.EQ.0)THEN
        JC(1) = 0
        JC(21) = 1
      ENDIF
      NJX1 = NSP(1)
C
C  EQUIVALENT REFLECTIONS AND PHASE SHIFTS
      DHKL(1) = 0.0
      KH(1,1) = 12
      KH(2,1) = 1200
      KH(3,1) = 120000
      CALL SMTRY2
      DO 145 J=1,IC
       DO 140 I=1,3
        IF ( IABS(KH(I,J)).EQ.12     ) K=MOD(ISIGN(1,KH(I,J))+9,9)
        IF ( IABS(KH(I,J)).EQ.1200   ) K=MOD(ISIGN(2,KH(I,J))+9,9)
        IF ( IABS(KH(I,J)).EQ.1212   ) K=MOD(ISIGN(3,KH(I,J))+9,9)
        IF ( IABS(KH(I,J)).EQ.120000 ) K=MOD(ISIGN(4,KH(I,J))+9,9)
 140    HFX(I,J) = HF(K)
        KD(J) = DHKL(J)+363636.1
        IDH(1,J) = MOD(MOD(KD(J),100),12)
        IDH(2,J) = MOD(MOD(KD(J)/100,100),12)
        IDH(3,J) = MOD(KD(J)/10000,12)
 145  CONTINUE
C
C  CALL SYMOPR
      X(1,1) = 0.01852
      X(1,2) = 0.02778
      X(1,3) = 0.03704
      X(1,4) = 0.0
      X(1,5) = 0.0
      X(1,6) = 0.0
      X(1,7) = 0.0
      X(1,8) = 0.0
      X(1,9) = 0.0
      CALL SYMOPR
C
C  EVALUATE SITES AND ELIMINATE REDUNDANCIES
      IP = 0
      DO 200 I=1,MULT
      K = I-1
      IX = 108.0*X(I,1)+1.1
      IY = 108.0*X(I,2)+1.1
      IZ = 108.0*X(I,3)+1.1
      IX1(I) = MOD(IX,9)
      IY1(I) = MOD(IY,9)
      IZ1(I) = MOD(IZ,9)
      IF ( K.EQ.0 ) GO TO 180
C  REMOVE POSITIONS DUE TO 1BAR SYMMETRY
      IF ( JC(1).GT.0 ) GO TO 160
      IF ( NC.GT.0 ) GO TO 160
      DO 150 J=1,K
      IF ( EXOR(NCTR(J),NCTR(I)).EQ.290 ) GO TO 200
  150 CONTINUE
  160 CONTINUE
C  REMOVE POSITIONS DUE TO LATTICE TRANSLATIONS
      IF ( JC(2).GT.0 ) GO TO 180
      DO 170 J=1,K
      IF ( IABS(IX1(I)-IX1(J))+IABS(IY1(I)-IY1(J))+IABS(IZ1(I)-IZ1(J))
     1 .EQ.0 ) GO TO 200
  170 CONTINUE
  180 CONTINUE
C  RECORD THIS SET OF POSITIONS
      IP = IP+1
      XOPR(1,IP) = OPR(IX)
      XOPR(2,IP) = OPR(IY)
      XOPR(3,IP) = OPR(IZ)
 200  CONTINUE
 510  IU = NC+1
*
* LFLG IS THE FIRST ENTRY IN THE LAST SYMMETRY CARD OF THE
* ORTEP INPUT FILE. 1 INDICATES LAST SYMMETRY CARD
* -1 INDICATES 1BAR SYMMETRY 2 INDICATES LATTICE TRANSLATION
* CARD TO FOLLOW -2 INDICATES COMBINATION OF TRANSLATIONAL 
* AND 1BAR SYMMETRY
*
      LFLG = 1
*
* IF JC(21) EQUALS 1 THEN THERE IS 1BAR SYMMETRY
*
      IF(JC(21).EQ.1)THEN
        LFLG = -1
      ENDIF
*
* IF JC(22) EQUALS 1 THEN THERE IS TRANSLATIONAL SYMMETRY
*
      IF(JC(22).EQ.1)THEN
        LFLG = 2
      ENDIF
      IF(JC(21).EQ.1.AND.JC(22).EQ.1)THEN
        LFLG = -2
      ENDIF
*
* WRITE THE SYMMETRY CARDS TO THE ORTEP FILE
*
      DO 250 J=1,IP
      IF(J.EQ.IP)THEN
        WRITE(10,14)LFLG,(XOPR(I,J),I=1,3)
        IF(BNAME.NE.' ')THEN
          WRITE(11,14)LFLG,(XOPR(I,J),I=1,3) 
        ENDIF
      ELSE
        WRITE(10,15)(XOPR(I,J),I=1,3)
        IF(BNAME.NE.' ')THEN
          WRITE(11,15)(XOPR(I,J),I=1,3)
        ENDIF
      ENDIF
 250  CONTINUE
 15   FORMAT(' 0  ',A14,'  ',A14,'  ',A14)
 14   FORMAT(I2,'  ',A14,'  ',A14,'  ',A14)
      IF(JC(22).EQ.1)THEN
        WRITE(10,29)LATRAN
        IF(BNAME.NE.' ')THEN
          WRITE(11,29)LATRAN
        ENDIF
      ENDIF
 29     FORMAT(A60)
      WRITE(10,8)BLK
      IF(BNAME.NE.' ')THEN
        WRITE(11,8)BLK
      ENDIF
*      
* GET THE ATOM POSITION COORDINATES
*
 404  WRITE(6,16)
 16     FORMAT(' Now the atom position coordinates and'/
     1' specifications must be entered.'/
     2' The necessary information includes a eight digit character'/
     3' string atom label, the element number, the ionic radius,'/
     4' and the X, Y, and Z coordinates and the pen number for'/
     4' drawing the atom. The element numbers should be positive or'/
     4' negative reflecting their ionic charge to identify which atoms'/
     5' should be bonded together.'/
     5' '/
     5' How many atoms are to be entered?')
      READ(6,17,ERR=404)NATOMS
 17     FORMAT(I2)
      IF(NATOMS.GT.1)THEN
 405    WRITE(6,34)
        READ(6,17,ERR=405)IELE
      ELSE
        IELE = 1
      ENDIF
 34     FORMAT(' How many different elements are to be entered?')
      NATOM = NATOMS
 406  WRITE(6,18)
 18     FORMAT(' Is there an atom at the cell center?'/
     1' <<0>> no, <1> yes'/
     2' If yes this atom should be the first atom entered.')
      READ(6,19,ERR=406)ICENT
 19     FORMAT(A1)
      ITB = 2
      IF(ICENT.EQ.'0'.OR.ICENT.EQ.' ')THEN
       WRITE(10,20)
 20     FORMAT('C_CENTER 0.0  0.0   0.500000  0.500000  0.500000  0.0
     1   0'/'0.0   0.001,,,,,, 6')
        NATOM = NATOM + 1
        IF(BNAME.NE.' ')THEN
          WRITE(11,20)
        ENDIF
      ELSE
        ITB = 1
      ENDIF
 407  WRITE(6,21)
 21     FORMAT(' Is there an atom at the cell corner?'/
     1' <<0>> no, <1> yes'/
     2' If yes this atom should be the first atom entered'/
     3' or follow the center atom.')
      READ(6,19,ERR=407)ICORN
      IF(ICORN.EQ.'0'.OR.ICORN.EQ.' ')THEN
       WRITE(10,22)
 22     FORMAT('C_CORNER 0.0  0.0   0.000000  0.000000  0.000000   0.0
     1  9'/'0.0   0.001,,,,,, 6')
        NATOM = NATOM + 1
        IF(BNAME.NE.' ')THEN
          WRITE(11,22)
        ENDIF
      ENDIF
      WRITE(6,23)NATOMS
 23    FORMAT(' Now enter the ',I2,'atoms as follows:'/
     1' LABEL   ELEMENT#,IONIC RADIUS,X,Y,Z,PEN NUMBER'/
     2' Example:'/
     3' COPPER  1,0.720,0.350,0.350,0.500,4'/
     4' OXYGEN  -2,1.40,0.500,0.250,0.250,2')
*
        RMAX = 0.1
      DO 300 I=1,NATOMS
 302    WRITE(6,24)I
        READ(6,25,ERR=304)ALABEL(I),NELEM(I),RADI(I),XX(I),
     1YY(I),ZZ(I),ICOL(I)
        WRITE(6,41)ALABEL(I),NELEM(I),RADI(I),XX(I),YY(I),ZZ(I),ICOL(I)
        READ(6,42)OK
        IF(OK.EQ.'1'.OR.OK.EQ.' ')THEN
          GO TO 301
        ELSE
          GO TO 302
        ENDIF
 301    IF(RADI(I).EQ.0.0)THEN
          RADI(I) = 1.0
        ENDIF
        IF(RADI(I).GT.RMAX)THEN
          RMAX = RADI(I)
        ENDIF
        INELEM(I) = IABS(NELEM(I))
        GO TO 300
 304    PRINT*,'There was an error in the last input line.'
        GO TO 302
 300  CONTINUE
      DO 310 I=1,NATOMS      
        WRITE(10,26)ALABEL(I),XX(I),YY(I),ZZ(I),INELEM(I)
        IF(BNAME.NE.' ')THEN
          WRITE(11,26)ALABEL(I),XX(I),YY(I),ZZ(I),INELEM(I) 
        ENDIF
        RADII(I) = RADI(I)/RMAX
        IF(I.EQ.NATOMS)THEN
          WRITE(10,28)RADII(I)
          IF(BNAME.NE.' ')THEN
            WRITE(11,28)RADII(I)
        ENDIF
        ELSE
          WRITE(10,27)RADII(I)
          IF(BNAME.NE.' ')THEN
            WRITE(11,27)RADII(I)
          ENDIF
        ENDIF
 310  CONTINUE
 24     FORMAT(' Enter the information for atom #',I2) 
 25     FORMAT(A8,I4,4F7.4,I1)
 41     FORMAT(' Are the following correct? <0> no, <<1>> yes:'/
     1,1X,A8,2x,I4,2x,4F7.4,2x,I1)
 42     FORMAT(A1)
 26     FORMAT(A8,' 0.0  0.0',3X,F8.6,2X,F8.6,2X,F8.6,'  0.0  ',I2)
 27     FORMAT('0.0',3X,F5.3,',,,,,, 6')
 28     FORMAT('1.0',3X,F5.3,',,,,,, 6')
      WRITE(10,8)BLK
*
* WRITE BOND DISTANCE SEARCH CODES
*
      IF(BNAME.NE.' ')THEN
        WRITE(11,8)BLK
        WRITE(11,51)NATOM,NATOM
 51       FORMAT('3  102  155501  ',I2,3X,'1',2X,I2,'  4.0'/
     1'====>VECTOR SEARCH CODE TO CALCULATE BOND DISTANCES'/
     2', -1')
        CLOSE(UNIT=11)
      ENDIF
*
* DIFFERENTIATE ANIONS FROM CATIONS TO DETERMINE WHICH
* ARE BONDED TO WHOM.
*
      II = 0
      JJ = 0
      DO 350 I=1,NATOMS
        IF(NELEM(I).LT.0)THEN
          IF(II.GT.0)THEN
            DO 345 J=1,II
              IF(IANION(J).EQ.INELEM(I))GOTO 350
 345        CONTINUE
          ENDIF
          II = II + 1
          IANION(II) = INELEM(I)
        ELSE
          IF(JJ.GT.0)THEN
            DO 346 J=1,JJ
              IF(ICATION(J).EQ.INELEM(I))GOTO 350
 346        CONTINUE
          ENDIF
          JJ = JJ + 1
          ICATION(JJ) = INELEM(I)
        ENDIF
 350  CONTINUE
*
* WRITE THE PLOTTING INSTRUCTIONS TO THE ORTEP FILE
*
      WRITE(10,30)ITB,NATOM
 30   FORMAT('3  301   10   8   10  1'/
     1'=====> SET GRAPH SIZE,  VIEWING DISTANCE,  AND THE INSIDE 
     2 MARGIN.'/
     4'3  303  0.0'/
     5'=====> SET RETRACING FEATURE.'/
     7'3  501  155501  155501  165501  155501  155601,, 1'/
     8'=====> SET THE REFERENCE COORDINATE SYSTEM 
     9( PROJECTION FROM B-AXIS ).'/
     B'3  502  1  0  2  0  3  0'/
     C'=====> SET THE REFERENCE SYSTEM ROTATION.'/
     E'3  410'/
     F'=====> CLEAR THE ATOMS ARRAY.'/
     H'3  404  155501  1  ',I1,'  ',I2,'  0.5  0.5  0.5'/
     I'=====> TRICLINIC BOX ENCLOSURE ABOUT DUMMY ATOM #1.'/
     K'3  604,,,, 3.0'/
     L'=====> AUTO SCALE AND POSITION TO ?% PROBABILITY ELLIPSOIDS.'/
     N'1  511  0.03'/
     O'1,    ,  255501  255601  255501  265501  255501  256501'/
     P'1,    ,  266601  256601  266601  266501  266601  265601'/
     Q'1,    ,  266501  256501  266501  265501  265501  265601'/
     R'2,    ,  265601  255601  255601  256601  256601  256501')
*
      IF(IELE.EQ.1)THEN
        WRITE(10,53)
      ENDIF
 53      FORMAT('3,  ,  ,  ,  , 2,    ,  , 0.01')
*
      DO 370 I=1,II
        DO 360 J=1,JJ
           IF(I.EQ.II.AND.J.EQ.JJ)THEN
             WRITE(10,43)ICATION(J),IANION(I)
           ELSE
             WRITE(10,33)ICATION(J),IANION(I)
           ENDIF
 360    CONTINUE
 370  CONTINUE
 33     FORMAT('2   ',I2,'  0  ',I2,'  0  2  0.5  3.75  0.01')
 43     FORMAT('3   ',I2,'  0  ',I2,'  0  2  0.5  3.75  0.01')
*
      WRITE(10,44)
 44     FORMAT('=====> VECTOR SEARCH CODE FOR DRAWING BONDS, PREPARED 
     VTO REMOVE OVERLAP.'/
     W' '/
     X'3  201'/
     Y'=====> INITIALIZE THE PLOTTER.')
*
      WRITE(10,31)
 31    FORMAT('3  999  1'/
     1'=====> PEN NUMBER FOR DRAWING CELL EDGES'/
     2'1, 811,  255501  255601  255501  265501  255501  256501'/
     3'1,    ,  266601  256601  266601  266501  266601  265601'/
     4'1,    ,  266501  256501  266501  265501  265501  265601'/
     5'2,    ,  265601  255601  255601  256601  256601  256501'/
     6'3,  ,  ,  ,  , 2,    ,  , 0.01'/
     7'=====> VECTOR DESIGNATE CODES FOR DRAWING CELL EDGES')
*
      DO 320 I=1,NATOMS
        INO = 0
        DO 330 J=1,NATOMS
          IF(INELEM(I).EQ.NELE(J))THEN
           INO=1
          ENDIF
 330    CONTINUE
        NELE(I)=INELEM(I)
        IF(INO.NE.1)THEN
        WRITE(10,32)ICOL(I),INELEM(I),INELEM(I)
        ENDIF
 320  CONTINUE
 32     FORMAT('3  999  ',I2/
     1'=====> PEN NUMBER FOR DRAWING TYPE ',I2,' ATOMS'/
     2'1  701'/
     3' ,,,, ',I2,'  0'/
     4' ')
      IF(IELE.GT.1)THEN
        WRITE(10,35)
      ENDIF
 35   FORMAT('3  999  7'/
     1'=====> PEN NUMBER FOR DRAWING BONDS'/
     2'2  812')
*
      DO 390 I=1,II
        DO 380 J=1,JJ
           IF(I.EQ.II.AND.J.EQ.JJ)THEN
             WRITE(10,37)ICATION(J),IANION(I)
           ELSE
            WRITE(10,33)ICATION(J),IANION(I)
           ENDIF
 380    CONTINUE
 390  CONTINUE
 37     FORMAT('3   ',I2,'  0  ',I2,'  0  2  0.5  3.75  0.01'/
     4'=====> VECTOR SEARCH CODE,  DRAW BONDS BETWEEN 
     5CATIONS AND ANIONS.')
      WRITE(10,52)
 52   FORMAT(', -1')
       CLOSE(UNIT=10)
      WRITE(6,55)ONAME
 55    FORMAT(' The ortep file has been written to the file',
     12X,A12,'.TEP')
      STOP
      END

      FUNCTION EXOR(I,J)
C
      INTEGER EXOR
C     EXOR  = IAND(IOR(I,J),ICOMPL(IAND(I,J)))
      EXOR  = IAND(IOR(I,J),NOT(IAND(I,J)))
      RETURN
      END

      SUBROUTINE SPGP
C
      INTEGER EXOR
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
      DIMENSION CHR(21),L(4,4),ICO(6,15)
      DIMENSION NDAT(7)
      DATA NDAT/3,1,2,0,2,1,3/
      DATA CHR/1H ,1HC,1HB,1HA,1HP,1HF,1HI,1HR,1HM,
     1 1HN,1HD,1H1,1H2,1H3,1H4,1H5,1H6,1H-,1H/,1HH,1H./
      LODGDF(I,J) = IAND(EXOR(I,J),307)
C
    1 FORMAT (/' The space group is ',80A1)
    2 FORMAT (' Did you enter it correctly?'/
     1 ' Errors of some sort were detected.'/
     2 '0The input was read as: ', 80A1)
   24 FORMAT (' A center is present, not at 0,0,0')
C
      PRINT 1,SPGC
      DO 97 I=1,90
   97 ICO(I,1) = 0
      DO 98 I=1,16
   98 L(I,1) = 0
      K = 1
      M = 1
      NSP(1) = 0
      NSP(2) = 0
      N = 0
      DO 110 J=1,20
   99 DO 100 I=1,21
      IF ( SPGC(J).EQ.CHR(I) ) GO TO 101
  100 CONTINUE
      GO TO 110
  101 IF ( K+M+I.EQ.3 ) GO TO 110
      IF ( I.EQ.1 ) GO TO 108
      L(M,K) = I
      N = 0
      M = M+1
      IF ( M-4 ) 110,110,108
  108 IF ( N.EQ.1 ) GO TO 110
      N = 1
      M = 1
      K = K+1
      IF ( K.GT.4 ) GO TO 200
  110 CONTINUE
  200 IF ( K.LE.2 ) GO TO 500
      IF ( L(1,1).GT.8 ) GO TO 500
      J = 1
      I = L(1,1)-1
      GO TO (203,202,201,119,204,205,206),I
  201 NCONT(J) = 576
      GO TO 209
  202 NCONT(J) = 516
      GO TO 209
  203 NCONT(J) = 68
      GO TO 209
  204 NCONT(J) = 576
      J = J+1
      GO TO 202
  205 NCONT(J) = 580
      GO TO 209
  207 K = K-1
      NSP(1) = K+3
      GO TO 210
  206 IF ( L(1,3).EQ.8.OR.L(1,4).EQ.8 ) GO TO 207
      NCONT(J) = 8192
      IF ( L(1,K-1).EQ.20 ) K=K-1
      NSP(1) = K+5
      J = J+1
      GO TO 210
  209 J = J+1
  119 IF ( K-4 ) 120,130,140
  120 IF ( L(1,2).EQ.18 ) GO TO 121
      IF ( L(1,2).EQ.17 ) GO TO 122
      IF ( L(1,2).EQ.14 ) GO TO 123
      IF ( L(1,2).EQ.15 ) GO TO 124
      IF ( L(1,2).EQ.12 ) GO TO 125
      NSP(1) = 2
      NSP(2) = 2
      GO TO 210
  121 IF ( L(2,2).EQ.17 ) GO TO 122
      IF ( L(2,2).EQ.14 ) GO TO 123
      IF ( L(2,2).EQ.15 ) GO TO 124
      IF ( L(2,2).EQ.12 ) GO TO 125
      GO TO 500
  122 NSP(1) = 11
      GO TO 210
  123 NSP(1) = 8
      GO TO 210
  124 NSP(1) = 4
      GO TO 210
  125 NSP(1) = 1
      GO TO 210
  130 IF ( L(1,3).NE.14 ) GO TO 500
      NSP(1) = 13
      GO TO 210
  140 IF ( L(1,3).EQ.14 ) GO TO 151
      IF ( L(1,2).EQ.18 ) GO TO 152
      IF ( L(1,2).EQ.17 ) GO TO 153
      IF ( L(1,2).EQ.14 ) GO TO 154
      IF ( L(1,2).EQ.15 ) GO TO 155
      IF ( L(1,2).EQ.12 ) GO TO 141
      IF ( L(1,3).EQ.12 ) GO TO 142
      IF ( L(1,4).EQ.12 ) GO TO 500
      NSP(1) = 3
      GO TO 210
  141 IF ( L(1,3).EQ.12 ) GO TO 143
      IF ( L(1,4).NE.12 ) GO TO 500
      NSP(1) = 2
      NSP(2) = 2
      GO TO 210
  142 IF ( L(1,4).NE.12 ) GO TO 500
      NSP(1) = 2
      NSP(2) = 1
      GO TO 210
  143 IF ( L(1,4).EQ.12 ) GO TO 500
      NSP(1) = 2
      NSP(2) = 3
      GO TO 210
  151 NSP(1) = 14
      GO TO 210
  152 IF ( L(2,2).EQ.17 ) GO TO 153
      IF ( L(2,2).EQ.14 ) GO TO 154
      IF ( L(2,2).EQ.15 ) GO TO 155
      GO TO 500
  153 NSP(1) = 12
      GO TO 210
  154 IF ( L(1,3).EQ.12 ) GO TO 156
      IF ( L(1,4).NE.12 ) GO TO 500
      NSP(1) = 9
      GO TO 210
  155 NSP(1) = 5
      GO TO 210
  156 IF ( L(1,4).EQ.12 ) GO TO 123
      NSP(1) = 10
  210 K = K-1
      N = 1
      DO 300 M=2,K
      IF ( L(1,M).EQ.0 ) GO TO 500
  218 I = IABS(L(1,M)-5)
  219 IF ( I.LE.0.OR.I.GT.15 ) GO TO 500
      GO TO (220,220,220,220,220,245,250,255,260,265,500,270,275,300,
     1 300),I
  220 GO TO (500,221,222,223),M
  221 IF ( L(1,3).EQ.14 ) GO TO 2230
      IF ( L(1,2).EQ.15 ) GO TO 2230
      IF ( L(1,2).EQ.17 ) GO TO 2230
      IF ( K.EQ.2 ) GO TO 2220
 2210 ICO(1,N) = 2
      ICO(2,N) = 0
      ICO(3,N) = 0
      ICO(4,N) = 4
      IF ( I.EQ.2.OR.I.EQ.5 ) ICO(5,N) = 1
      IF ( I.EQ.3.OR.I.EQ.5 ) ICO(6,N) = 1
 2211 N = N+1
      IF ( L(1,2).NE.15 ) GO TO 300
      ICO(1,N) = ICO(2,N-1)
      ICO(2,N) = ICO(1,N-1)
      ICO(3,N) = ICO(3,N-1)
      ICO(4,N) = ICO(5,N-1)
      ICO(5,N) = ICO(4,N-1)
      ICO(6,N) = ICO(6,N-1)
      N= N+1
      GO TO 300
  222 IF ( L(1,2).EQ.14.OR.L(1,2).EQ.17 ) GO TO 225
      IF ( L(1,2).EQ.15 ) GO TO 2210
 2220 ICO(1,N) = 0
      ICO(2,N) = 2
      ICO(3,N) = 0
      ICO(5,N) = 4
      IF ( I.EQ.1.OR.I.EQ.5 ) ICO(4,N) = 1
      IF ( I.EQ.3.OR.I.EQ.5 ) ICO(6,N) = 1
      N = N+1
      GO TO 300
  223 IF ( L(1,3).EQ.14.OR.L(1,2).EQ.15 ) GO TO 224
      IF ( L(1,2).EQ.14.OR.L(1,2).EQ.17 ) GO TO 224
 2230 ICO(1,N) = 0
      ICO(2,N) = 0
      ICO(3,N) = 2
      ICO(6,N) = 4
      IF ( I.EQ.1.OR.I.EQ.5 ) ICO(4,N) = 1
      IF ( I.EQ.2.OR.I.EQ.5 ) ICO(5,N) = 1
      N = N+1
      IF ( M.EQ.2.AND.L(1,2).EQ.15.AND.I.EQ.5 ) ICO(4,N-3)=1
      IF ( M.NE. 2.OR.L(1,2).NE.17) GO TO 300
      IF ( L(1,3).EQ.2 ) ICO(6,N-1)=1
      IF ( L(1,4).EQ.2 ) ICO(6,N-1)=MOD(ICO(6,N-1)+1,2)
      GO TO 300
  224 ICO(1,N) = 1
      ICO(2,N) = 1
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      IF ( I.EQ.3.OR.I.EQ.5 ) ICO(6,N) = 1
      IF ( NSP(1).EQ.7.AND.I.EQ.3 ) GO TO 2240
      IF ( I.NE.5 ) GO TO 226
 2240 ICO(4,N) = 5
      ICO(5,N) = 5
      N = N+1
      GO TO 300
  225 IF ( NSP(1).EQ.7 ) GO TO 224
      ICO(1,N) = 3
      ICO(2,N) = 3
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      IF ( I.EQ.3 ) ICO(6,N) = 1
  226 N = N+1
      GO TO 300
C    D TYPE MIRROR
  245 GO TO (500,246,247,248),M
  246 IF ( K.EQ.2 ) GO TO 247
      ICO(1,N) = 2
      ICO(2,N) = 0
      ICO(3,N) = 0
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      N = N+1
      GO TO 300
  247 ICO(1,N) = 0
      ICO(2,N) = 2
      ICO(3,N) = 0
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      N = N+1
      GO TO 300
  248 IF ( L(1,2).EQ.15.OR.L(1,3).EQ.14 ) GO TO 249
      ICO(1,N) = 0
      ICO(2,N) = 0
      ICO(3,N) = 2
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      N = N+1
      GO TO 300
  249 ICO(1,N) = 1
      ICO(2,N) = 1
      ICO(3,N) = 0
      ICO(4,N) = 6
      ICO(5,N) = 6
      ICO(6,N) = 6
      IF (L(1,3).NE.13) GO TO 226
      ICO(4,N) = 0
      ICO(5,N) = 1
      N = N+1
      GO TO 300
C    1 FOLD ROTATION
  250 IF ( L(2,M).NE.3 ) GO TO 300
      ICO(1,N) = 2
      ICO(2,N) = 2
      ICO(3,N) = 2
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 4
      N = N+1
      GO TO 300
  255 GO TO (500,256,257,258),M
C    2 FOLD ROTATION
  256 IF ( K.EQ.2 ) GO TO 2571
 2561 ICO(1,N) = 0
      ICO(2,N) = 2
      ICO(3,N) = 2
      ICO(4,N) = 0
      ICO(5,N) = 4
      ICO(6,N) = 4
      IF ( IABS(L(2,M)-13).EQ.1 ) ICO(4,N) = 1
 2560 N = N+1
      DO 2562 I=2,4
      IF ( L(I,M).EQ.19 ) GO TO 2563
 2562 CONTINUE
      GO TO 300
 2563 IF ( L(I+1,M).LE.1 ) GO TO 500
      I = IABS(L(I+1,M)-5)
      GO TO 219
  257 IF ( L(1,2).EQ.14.OR.L(1,2).EQ.17 ) GO TO 259
 2571 ICO(1,N) = 2
      ICO(2,N) = 0
      ICO(3,N) = 2
      ICO(4,N) = 4
      ICO(5,N) = 0
      ICO(6,N) = 4
      IF ( L(2,M).EQ.12 ) ICO(5,N)=1
      IF ( L(1,2).EQ.15 ) GO TO 2211
      GO TO 2560
  258 IF ( L(1,2).GE.14   ) GO TO 2595
      IF ( L(1,3).EQ.14 ) GO TO 259
 2581 ICO(1,N) = 2
      ICO(2,N) = 2
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 0
      IF ( IABS(L(2,M)-13).EQ.1 ) ICO(6,N) = 1
      IF (      L(2,M).EQ.16    ) ICO(6,N) = 1
      GO TO 2560
  259 IF ( L(1,3).EQ.8.OR.L(1,4).EQ.8 ) GO TO 2595
      ICO(1,N) = 1
      ICO(2,N) = 1
      ICO(3,N) = 2
      ICO(4,N) = 0
      ICO(5,N) = 0
      ICO(6,N) = 4
      GO TO 2560
 2595 IF ( L(1,2).EQ.15)GO TO 259
      ICO(1,N) = 3
      ICO(2,N) = 3
      ICO(3,N) = 2
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 4
      GO TO 2560
C    3 FOLD ROTATION
  260 GO TO (500,261,262,500),M
  261 IF ( L(1,1).EQ.8.AND.J.EQ.1 ) GO TO 262
      IX = 0
      IF ( L(2,M).EQ.12 ) GO TO 2611
      IF ( L(2,M).EQ.13 ) GO TO 2612
 2610 NCONT(J) = 8196
      GO TO 2613
 2611 NCONT(J) = 8200
      IF ( L(1,4).NE.13 ) GO TO 2613
      J = J+1
      NCONT(J) = 2321
      IF ( L(1,2).EQ.14 ) NCONT(J)=4403
      L(1,3) = 12
      L(1,4) = 12
      GO TO 2613
 2612 NCONT(J) = 8204
      IF ( L(1,4).NE.13 ) GO TO 2613
      J = J+1
      NCONT(J) = 4369
      IF ( L(1,2).EQ.14 ) NCONT(J)=2355
      L(1,3) = 12
      L(1,4) = 12
 2613 J = J+1
      IF ( IX-1 ) 250,2581,2230
C    CUBIC OR RHOMBOHEDERAL
  262 NCONT(J) = 16384
      IF (L(2,M).NE.3 ) GO TO 2620
      J = J+1
      NCONT(J) = 290
 2620 J = J+1
      IF ( N.EQ.1 ) GO TO 300
      I = N-1
      IN1 = N
      IN2 = N+1
      ICO(1,IN1) = ICO(3,I)
      ICO(2,IN1) = ICO(1,I)
      ICO(3,IN1) = ICO(2,I)
      ICO(4,IN1) = ICO(6,I)
      ICO(5,IN1) = ICO(4,I)
      ICO(6,IN1) = ICO(5,I)
      ICO(1,IN2) = ICO(2,I)
      ICO(2,IN2) = ICO(3,I)
      ICO(3,IN2) = ICO(1,I)
      ICO(4,IN2) = ICO(5,I)
      ICO(5,IN2) = ICO(6,I)
  263 ICO(6,IN2) = ICO(4,I)
      N = IN2+1
      GO TO 300
  265 IF ( M.NE.2 ) GO TO 500
      ICO(1,N) = 3
      ICO(2,N) = 1
      ICO(3,N) = 0
      ICO(4,N) = 4
      ICO(5,N) = 4
      ICO(6,N) = 0
      IF ( L(2,2).EQ.12 ) ICO(6,N) = 2
      IF ( L(2,2).EQ.13 ) ICO(6,N) = 1
      IF ( L(2,2).EQ.14 ) ICO(6,N) = 3
      IF ( L(2,2).EQ. 3 ) ICO(3,N) = 2
      N = N+1
      IF ( L(2,2).EQ.3.AND.L(1,3).EQ.14.AND.L(1,4).EQ.11 ) GO TO 266
      IF ( L(1,3).EQ.14 ) GO TO 2561
      IF ( K.GT.2.OR.L(1,1).NE.7 ) GO TO 2581
      IF ( L(2,2)+L(3,2).NE.12 ) GO TO 2581
      L(2,2) = 0
      ICO(5,N-1) = 1
      GO TO 2581
  266 IF ( L(1,1).NE.7.OR.L(1,2).NE.15 ) GO TO 500
      NCONT(J  ) = 16384
      NCONT(J+1) = 356
      NCONT(J+2) = 834
      NCONT(J+3) = 1177
      J = J+3
      GO TO 410
  270 IF ( M.NE.2 ) GO TO 500
      IX = 1
      IF ( L(2,2).EQ.12 ) GO TO 2611
      IF ( L(2,2).EQ.13 ) GO TO 2612
      IF ( L(2,2).EQ.14 ) GO TO 2610
      IF ( L(2,2).EQ.15 ) GO TO 2611
      IF ( L(2,2).EQ.16 ) GO TO 2612
      IF ( L(2,2).EQ. 3 ) GO TO 271
      GO TO 2610
  271 IX = 2
      GO TO 2610
  275 IF ( M.NE.2 ) GO TO 500
      L(1,2) = L(2,2)
      L(2,2) = 3
      GO TO 218
  300 CONTINUE
      N = N-1
      IJ = J
      IF ( N.GT.0 ) GO TO 301
      J = J-1
      GO TO 410
  301 DO 305 I=1,N
      NCONT(J) = ICO(1,I)+16*ICO(2,I)+128*ICO(3,I)+4*MOD(ICO(4,I),4)
     1 +64*MOD(ICO(5,I),4)+ 512*MOD(ICO(6,I),4)
  305 J = J+1
  306 J = J-1
  310 DO 400 I=IJ,J
      NCI = I-IJ+1
      ICO4 = MOD(ICO(4,NCI),4)
      ICO5 = MOD(ICO(5,NCI),4)
      ICO6 = MOD(ICO(6,NCI),4)
      NI4 = NDAT(ICO4+4)
      NI5 = NDAT(ICO5+4)
      NI6 = NDAT(ICO6+4)
      KJ = I+1
      IF ( IAND(NCONT(I),307)-290 ) 320,315,320
  315 IF ( IAND(NCONT(I),7884) ) 316,318,316
C   A CENTER IS PRESENT, NOT AT 0,0,0
  316 CONTINUE
      WRITE(6,24)
      GO TO 320
C   A CENTER AT 0,0,0 IS PRESENT
  318 CONTINUE
  320 IF ( KJ.GT.J ) GO TO 400
      DO 390 K=KJ,J
      NCK = K-IJ+1
      KCO4 = MOD(ICO(4,NCK),4)
      KCO5 = MOD(ICO(5,NCK),4)
      KCO6 = MOD(ICO(6,NCK),4)
      NK4 = NDAT(KCO4+4)
      NK5 = NDAT(KCO5+4)
      NK6 = NDAT(KCO6+4)
      NXC = MOD( NI4+ NK4,4)
      NYC = MOD( NI5+ NK5,4)
      NZC = MOD( NI6+ NK6,4)
      MJ = K+1
      LOD = LODGDF(NCONT(K),NCONT(I))
      IF ( LOD.NE.290 ) GO TO 330
C   A CENTER IS GENERATED
      IF ( NXC+NYC+NZC.EQ.0 ) GO TO 330
      IF ( L(1,2).EQ.15.AND.I.EQ.IJ+1 ) GO TO 324
  321 IF ( NXC.EQ.0 ) GO TO 322
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NXC)*4
  322 IF ( NYC.EQ.0 ) GO TO 323
      IF ( ICO(5,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NYC)*64
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
  323 IF ( NZC.EQ.0 ) GO TO 325
      IF ( ICO(6,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NZC)*512
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
      GO TO 325
  324 L(1,2) = 30
      NIJ = ICO(6,1)
      NIJ = NDAT(NIJ+4)
      NJX = MOD(NIJ+NXC,4)
      NCONT(IJ) = IAND(NCONT(IJ),2035)+NDAT(NJX+4)*4
      NCONT(IJ) = IAND(NCONT(IJ),1855)+NDAT(NIJ+4)*64
      GO TO 321
  325 CONTINUE
      ICO(4,NCI) = 0
      ICO(4,NCK) = 0
      ICO(5,NCK) = 0
      ICO(5,NCI) = 0
      ICO(6,NCI) = 0
      ICO(6,NCK) = 0
  330 CONTINUE
      ICO4 = MOD(NCONT(I)/4  ,4)
      IKO4 = MOD(NCONT(K)/4  ,4)
      ICO5 = MOD(NCONT(I)/64 ,4)
      IKO5 = MOD(NCONT(K)/64 ,4)
      ICO6 = MOD(NCONT(I)/512,4)
      IKO6 = MOD(NCONT(K)/512,4)
      NI4 = NDAT(ICO4+4)
      NK4 = NDAT(IKO4+4)
      NI5 = NDAT(ICO5+4)
      NK5 = NDAT(IKO5+4)
      NI6 = NDAT(ICO6+4)
      NK6 = NDAT(IKO6+4)
      IF ( MJ.GT.J ) GO TO 390
      DO 380 M=MJ,J
      NCM = M-IJ+1
      MCO4 = MOD(ICO(4,NCM),4)
      MCO5 = MOD(ICO(5,NCM),4)
      MCO6 = MOD(ICO(6,NCM),4)
      NM4 = NDAT(MCO4+4)
      NM5 = NDAT(MCO5+4)
      NM6 = NDAT(MCO6+4)
      LOD1 = LODGDF(LOD,NCONT(M))
      NXC = MOD( NI4+NK4+NM4,4)
      NYC = MOD( NI5+NK5+NM5,4)
      NZC = MOD( NI6+NK6+NM6,4)
      IF ( LOD1.NE.290 ) GO TO 350
       IF  ( L(1,2).EQ.11 ) GO TO 334
      IF ( NXC+NYC+NZC.EQ.0 ) GO TO 380
      IF ( IJ.EQ.1 ) GO TO 331
      IF(NXC + NYC .EQ.0 )GO TO 333
      IF ( L(1,3).EQ.14 ) GO TO 331
      IF ( L(1,2).EQ.15 ) GO TO 331
      IF ( L(1,2).EQ.14 ) GO TO 331
      IF ( L(1,2).EQ.17 ) GO TO 331
      IF ( L(1,2)+L(1,3)+L(1,4).LT.18.AND.L(1,2).NE.9 ) GO TO 331
      NXC = MOD(NCONT(1)/2  +NXC,4)
      NYC = MOD(NCONT(1)/32 +NYC,4)
      NZC = MOD(NCONT(1)/256+NZC,4)
  331 CONTINUE
      IF ( NXC.EQ.0 ) GO TO 332
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NXC)*4
      IF ( ICO(4,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NXC)*4
  332 IF ( NYC.EQ.0 ) GO TO 333
      IF ( ICO(5,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NYC)*64
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
      IF ( ICO(5,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NYC)*64
  333 IF ( NZC.EQ.0 ) GO TO 335
      IF ( ICO(6,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NZC)*512
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
      IF ( ICO(6,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NZC)*512
      GO TO 335
  334 NCONT(I) = IAND(NCONT(I),2035)
      NCONT(K) = IAND(NCONT(K),1855)
      NCONT(M) = IAND(NCONT(M),511)
  335 ICO(4,NCI) = 0
      ICO(5,NCI) = 0
      ICO(6,NCI) = 0
      ICO(4,NCK) = 0
      ICO(5,NCK) = 0
      ICO(6,NCK) = 0
      ICO(4,NCM) = 0
      ICO(5,NCM) = 0
      ICO(6,NCM) = 0
      GO TO 380
  350 IF ( LOD1.NE.0 ) GO TO 380
      IF ( NXC+NYC+NZC.EQ.0 ) GO TO 359
      IF ( L(1,2).EQ.30 ) GO TO 3500
      IF ( L(1,2).EQ.15 ) GO TO 355
      IF (  L (1,2).EQ.17 ) GO TO 359
      IF (  L (1,2).EQ.13 ) GO TO 351
      IF (  L (1,3).EQ.13 ) GO TO 352
      IF (  L (1,4).EQ.13 ) GO TO 353
      GO TO 500
 3500 IF ( NXC.EQ.0 ) GO TO 359
      IF ( L(4,2).EQ.4 ) GO TO 359
      IF ( NXC.EQ.NK4 ) GO TO 359
      NCONT(K) = IOR(NCONT(K),NDAT(NXC)*4)
      IF ( L(1,4).EQ.13.AND.L(2,4).EQ.0 ) GO TO 3580
      GO TO 359
  351 NYC = MOD( NK5+ NM5,4)
      NZC = MOD( NK6+ NM6,4)
      IF (  L (1,3).EQ.13 ) GO TO 354
      IF (  L (1,3).EQ.14 ) GO TO 354
      IF (  L (1,4).EQ.13 ) GO TO 354
      M2 = I+1
      IF(L(2,2).EQ.12.AND.(L(1,3).EQ.9 .OR.L(1,4).EQ.9))  GO TO 360
      IF ( NYC.LE.0 ) GO TO 3510
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
      IF ( ICO(5,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NYC)*64
 3510 IF ( NZC.LE.0 ) GO TO 360
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
      IF ( ICO(6,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NZC)*512
      GO TO 360
  352 NXC = MOD( NI4+ NM4,4)
      NZC = MOD( NI6+ NM6,4)
      M2 = K+1
      IF(L(2,3).EQ.12 .AND.(L(1,2).EQ.9 .OR. L(1,4).EQ.9)) GO TO 360
      IF ( NXC.LE.0 ) GO TO 3520
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NXC)*4
 3520 IF ( NZC.LE.0 ) GO TO 360
      IF ( ICO(6,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NZC)*512
      IF ( ICO(6,NCM).EQ.4 ) NCONT(M) = NCONT(M)+NDAT(NZC)*512
      GO TO 360
  353 NXC = MOD( NI4+ NK4,4)
      NYC = MOD( NI5+ NK5,4)
      IF(L(2,4).EQ.12 .AND. ( L(1,2).EQ.9.OR.L(1,3).EQ.9)) GO TO 359
      IF ( NXC.LE.0 ) GO TO 3530
      IF ( ICO(4,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NXC)*4
      IF ( ICO(4,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NXC)*4
 3530 IF ( NYC.LE.0 ) GO TO 359
      IF ( ICO(5,NCI).EQ.4 ) NCONT(I) = NCONT(I)+NDAT(NYC)*64
      IF ( ICO(5,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NYC)*64
      GO TO 359
  354 IF ( NYC.LE.0 ) GO TO 3540
      IF ( IABS(L(2,2)-13).EQ.1 ) NCONT(I)=NCONT(I)+NDAT(NYC)*64
 3540 IF ( NZC.LE.0 ) GO TO 3541
      IF ( ICO(6,NCK).EQ.4 ) NCONT(K) = NCONT(K)+NDAT(NZC)*512
 3541 IF ( NXC.LE.0 ) GO TO 359
      IF ( L(1,4).EQ.0.OR.L(1,3).EQ.14 ) GO TO 359
      IF ( L(2,4).NE.12 ) NCONT(K)=NCONT(K)+NDAT(NXC)*4
      GO TO 359
  355 L(1,2) = 30
      IF ( L(1,3).EQ.14 ) GO TO 370
      IF ( L(1,3).EQ.13.AND.L(2,3).EQ.12 ) GO TO 3561
      IF ( L(1,1).EQ. 7.AND.L(2,2).EQ.12 ) GO TO 357
      IF ( L(1,1).EQ. 7.AND.L(2,2).EQ.14 ) GO TO 357
      IF ( L(1,1).EQ. 6.AND.L(2,2).EQ.12 ) GO TO 358
      IF ( L(1,1).EQ. 6.AND.L(2,2).EQ.14 ) GO TO 358
      IF ( L(1,1).EQ.7.AND.L(1,3).EQ.13 ) GO TO 3581
      IF ( MOD(NCONT(I),1024).EQ.19 ) GO TO 350
      IF ( NXC+NYC.GT.0 ) GO TO 356
      IF ( NZC.NE.NM6 ) GO TO 359
      IF ( NZC.LE.0 ) GO TO 359
      NCONT(K) = NCONT(K)+NDAT(NZC)*512
      GO TO 359
  356 IF ( L(3,2).EQ.10.OR.L(4,2).EQ.10 ) GO TO 359
      IF ( L(1,3).NE.10 ) GO TO 359
 3561 IF ( L(2,2).EQ.3 ) GO TO 3560
      NCONT(I) = IOR(NCONT(I),68)
      GO TO 3580
 3560 IF ( L(1,4).EQ.2 ) NCONT(K)=IOR(NCONT(K),512)
      GO TO 359
  357 NCONT(I) = NCONT(I)+64
      IF ( L(3,2).NE.19 ) NCONT(I+1) = NCONT(I+1)-512
      IF ( L(1,4).EQ.11.AND.L(3,2).EQ.19 )NCONT(I) = NCONT(I)+588
      GO TO 3580
  358 NCONT(I) = NCONT(I)+136
 3580 IF ( L(1,3).NE.13 ) GO TO 359
 3581 M2 = K+1
      GO TO 360
  359 M2 = M+1
  360 CONTINUE
      IF ( M2.GT.J ) GO TO 306
      DO 365 M1=M2,J
      NCONT(M1-1) = NCONT(M1)
      DO 365 M3=1,6
  365 ICO(M3,M1-1) = ICO(M3,M1)
      GO TO 306
  370 IF ( L(1,4).GT.12 ) GO TO 371
      M2 = I+1
      GO TO 360
  371  CONTINUE
      L(1,2) = 13
      IF ( L(2,2).EQ.12.AND.L(1,1).EQ.5 ) NCONT(I) = NCONT(I)+200
      IF ( L(2,2).EQ.12.AND.L(1,1).EQ.6 ) NCONT(I) = NCONT(I)+136
      IF ( L(2,2).EQ.12.AND.L(1,1).EQ.7 ) NCONT(I) = NCONT(I)+652
      IF ( L(2,2).EQ.13 )                 NCONT(I) = NCONT(I)+68
      IF ( L(2,2).EQ.14 )                 NCONT(I) = NCONT(I)+140
      GO TO 359
  380 CONTINUE
  390 CONTINUE
  400 CONTINUE
      LD = 0
      DO 405 I=1,J
  405 LD = LODGDF(LD,NCONT(I))
      IF ( LD.NE.0 ) GO TO 410
      NCONT(J-1) = NCONT(J)
      J = J-1
  410 CONTINUE
      NCONT(J+1) = 0
  450 RETURN
  500 WRITE(6,2) SPGC
      NSP(2) = 4
      GO TO 450
      END

      SUBROUTINE OP1
C
      INTEGER EXOR
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
      COMMON/CRYDAT/ JUNK(1733),NCTR(192)
      COMMON/HKLCTL/ KH(3,24),DHKL(24),KHCO(10,7),IC,N1,IER,HM
C
      K = 2
      NPOL = 7
      DO 40 I=1,7
   40 KHCO(1,I) = 0
      NCTR(1) = 0
      DO 100 I=1,8
      IF ( NCONT(I).LE.0 ) GO TO 101
      IF ( NCONT(I).LT.8192 ) GO TO 80
      IF ( NCONT(I).LE.08192 ) GO TO 60
      IF ( NCONT(I).EQ.16384 ) GO TO 70
      NPOL = 4
      KHCO(I,1) = 2
   50 DO 51 J=2,7
   51 KHCO(I,J) = 0
      KHCO(I,6) = MOD(NCONT(I)/4,32)
      GO TO 90
   60 KHCO (I,1) = 3
      NPOL = 1
      GO TO 50
   70 KHCO(I,1) = 1
      GO TO 50
   80 KHCO(I,1) = 0
      KHCO(I,2) = MOD(NCONT(I),4)
      KHCO(I,3) = MOD(NCONT(I)/4,4)
      KHCO(I,4) = MOD(NCONT(I)/16,4)
      KHCO(I,5) = MOD(NCONT(I)/64,4)
      KHCO(I,6) = MOD(NCONT(I)/256,2)
      KHCO(I,7) = MOD(NCONT(I)/512,16)
   90 CONTINUE
      L = K-1
      DO 100 J=1,L
      IF ( NCONT(I).EQ.8192 ) GO TO 95
      NCTR(K) = IAND(EXOR(NCONT(I),NCTR (J )),57651)
      IF (IAND(NCONT(I),17).EQ.0) GO TO 92
      IF (IAND(NCTR(J),34).EQ.0) GO TO 92
      IF (IAND(NCTR(J),34).EQ.34) GO TO 92
      NCTR(K)=EXOR(NCTR(K),34)
   92 CONTINUE
      K = K+1
      IF ( NCONT(I).LT.8192 ) GO TO 100
      NCTR(K) = NCTR(K-1)+32768
      K = K+1
      GO TO 100
   95 CONTINUE
      NCTR(K  ) = 0
      NCTR(K+1) = 0
      K = K+2
  100 CONTINUE
  101 MULT = K-1
      N1 = I-1
      IF ( N1.LT.2 ) GO TO 105
      DO 102 N2=2,N1
      IF ( KHCO(N2-1,1).EQ.1 ) GO TO 103
  102 CONTINUE
      GO TO 105
  103 DO 104 I=N2,N1
      DO 104 J=1,7
  104 KHCO(I-1,J) = KHCO(I,J)
      KHCO(N1,1) = 1
  105 CONTINUE
      NC = 1
      DO 200 I=1,MULT
      IF ( EXOR(NCTR(I),290).EQ.0 ) NC = 0
      IF ( IAND(NCTR(I),3).GT.0 ) NPOL = IAND(NPOL,6)
      IF ( IAND(NCTR(I),48).GT.0 ) NPOL = IAND(NPOL,5)
  200 IF ( IAND(NCTR(I),256).GT.0 ) NPOL = IAND(NPOL,3)
      RETURN
      END

      SUBROUTINE SMTRY2
C
      INTEGER EXOR
      COMMON/HKLCTL/ KH(3,24),DHKL(24),KHCO(10,7),IC,N1,IER,HM
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
      COMMON /CNTRLS/ JC(20)
      DIMENSION KD(6),KE(3),KF(3)
      DIMENSION NCH(24),NCK(24),NCL(24)
      DIMENSION LD(3,24)
      INTEGER*4 IPH(24)
      REAL XPH(24), XTEM
      DATA KD,KE,KF/0,6,3,9,4,8,0,4,8,0,8,4/
C
      IF ( NC.GT.0 ) GO TO 14
      IF ( KH(1,1) ) 11,9,14
    9 IF ( KH(2,1) ) 12,10,14
   10 IF ( KH(3,1) ) 13,14,14
   11 KH(1,1) = -KH(1,1)
   12 KH(2,1) = -KH(2,1)
   13 KH(3,1) = -KH(3,1)
   14 CONTINUE
      IPH(1) = KH(3,1)+512*(KH(2,1)+512*KH(1,1))
      CI = 1.0
      IC = 1
      DHKL(1) = 0.0
      LD(1,1) = 0
      LD(2,1) = 0
      LD(3,1) = 0
      NCH(1) = 0
      NCK(1) = 0
      NCL(1) = 1
      IF ( N1.EQ.0 ) GO TO 1000
      L = 2
      DO 900 I=1,N1
      CI = CI*2.0
      IF ( KHCO(I,1).GT.0 ) CI = CI*1.5
      DO 890 J=1,IC
      NCO = KHCO(I,1)+1
      GO TO (20,700,800,15),NCO
   15 IF(MOD(KH(1,1)-KH(2,1)-KH(3,1),3).NE.0 ) GO TO 1002
      GO TO 900
   20 NCH(L) = EXOR(NCH(J),KHCO(I,2))
      IF ( MOD(KHCO(I,2),2).NE.0 ) NCH(L)=EXOR(NCK(J),KHCO(I,2))
      M = 1+MOD(NCH(L),2)
      MS = 1-2*MOD(NCH(L)/2,2)
      N = IABS(NCL(J))
      KH(M,L) = KH(1,N)*MS
      M = 1+MOD(KHCO(I,2),2)
      MS = 1-2*MOD(KHCO(I,2)/2,2)
      NCX = KHCO(I,3)+1
      LD(1,L) = KD(NCX)+LD(M,J)*MS
      NCK(L) = EXOR(NCK(J),KHCO(I,4))
      IF ( MOD(KHCO(I,4),2).NE.0 ) NCK(L)=EXOR(NCH(J),KHCO(I,4))
      M = 2-MOD(NCK(L),2)
      MS = 1-2*MOD(NCK(L)/2,2)
      KH(M,L) = KH(2,N)*MS
      M = 2-MOD(KHCO(I,4),2)
      MS = 1-2*MOD(KHCO(I,4)/2,2)
      NCX = KHCO(I,5)+1
      LD(2,L) = KD(NCX)+LD(M,J)*MS
      MS = (1-2*KHCO(I,6))*ISIGN(1,NCL(J))
      NCL(L) = MS*NCL(N)
      KH(3,L) = KH(3,N)*MS
   70 NCO = KHCO(I,7)+1
      IF ( NCO.GT.5 ) NCO=6
      MS = 1-2*KHCO(I,6)
      IF ( N.GT.1.AND.NCK(J).GE.4.AND.M.EQ.1 ) MS=-MS
      LD(3,L) = KD(NCO)+LD(3,J)*MS
   80 IXIT = 0
   81 CONTINUE
*      PRINT*,L
*      PRINT*,KH(1,L),KH(2,L),KH(3,L)
      XTEM = REAL(KH(2,L)+512*KH(1,L))/1000000.0
      XPH(L) = REAL(KH(3,L))/1000000.0 + 512.0*XTEM
*      PRINT*,XPH(L)
      IPH(L) = INT(XPH(L))
*      PRINT*,IPH(L)
*      IPH(L) = KH(3,L)+512*(KH(2,L)+512*KH(1,L))
   87 LA = LD(1,L)*KH(1,1)+LD(2,L)*KH(2,1)+LD(3,L)*KH(3,1)
      DHKL(L) = FLOAT(LA)/12.0
      IF ( NC.NE.0 ) GO TO 89
      IF ( NSP(1).LT.12 ) GO TO 89
      IF ( KHCO(I,1).GT.0 ) GO TO 89
      IF ( MOD(KHCO(I,2),2).EQ.1 ) GO TO 89
      IF ( IPH(L).LE.0 ) GO TO 680
   89 CONTINUE
      DO 90 M=2,L
      IF ( IPH(M-1).EQ.IPH(L) ) GO TO 690
      IF ( NC.NE.0 ) GO TO 90
      IF ( IPH(M-1).EQ.-IPH(L) ) GO TO 690
   90 CONTINUE
      L = L+1
  680 IF ( IXIT-1 ) 890,750,850
  690 IF ( AMOD(ABS(DHKL(L)-DHKL(M-1)),1.).NE.0. ) GO TO 1002
      GO TO 680
  700 IXIT = 2
      JD = J
  750 IXIT = IXIT-1
      LD(1,L) = LD(1,JD)
      LD(2,L) = LD(2,JD)
      LD(3,L) = LD(3,JD)
      NCH(L) = 0
      NCK(L) = 0
      NCL(L) = L
      K1JD = KH(1,JD)
      KH(1,L) = KH(2,JD)
      KH(2,L) = KH(3,JD)
      KH(3,L) = K1JD
      JD = L
      GO TO 81
  800 IXIT = 4
      JD = J
      NCO = KHCO(I,6)
  850 IXIT = IXIT-2
      NCH(L) = 0
      NCK(L) = 4
      NCL(L) = L
      LD(1,L) = 0
      LD(2,L) = 0
      KH(1,L) = -KH(1,JD)-KH(2,JD)
      KH(2,L) = KH(1,JD)
      KH(3,L) = KH(3,JD)
      LD(3,L) = KF(NCO)+LD(3,JD)
      IF ( MOD(NCH(J),2).NE.0 ) LD(3,L)=KE(NCO)+LD(3,JD)
      JD = L
      GO TO 81
  890 CONTINUE
  900 IC = L-1
 1000 IER = 0
      HM = CI/FLOAT(IC)
      IF ( NC.NE.0 ) GO TO 1001
      DO 1003 M=2,IC
      IF ( IPH(M).GT.0 ) GO TO 1003
      KH(1,M) = -KH(1,M)
      KH(2,M) = -KH(2,M)
      KH(3,M) = -KH(3,M)
 1003 CONTINUE
 1001 RETURN
 1002 IER = 1
      GO TO 1001
      END

      SUBROUTINE PRMTR
C
      REAL*8 TAB
      COMMON /XB/N3P,X(11,100),IXB(100),IF(2,100),G,N12(100)
      COMMON/SYML/ ISYM(100)
      COMMON/CRYDAT/ N,NMAX, IJKLM,Y(192,9),XLT,KXB,NCTR(192)
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
      COMMON /SYMTAB/TAB(62)
      DIMENSION IZB(10)
C
C   1 FORMAT (/' Positions generated for atom ',I3,F10.4,I10,10I2/(9F10.5
C    Z,I6))
    1 FORMAT(/' Positions for atom: ',I2,21H, Site Multiplicity: I2)
    2 FORMAT(/,11H  ----X----,11H  ----Y----,11H  ----Z----,
     +2X,11H  ----X----,11H  ----Y----,11H  ----Z----,//,
     +(X,F10.6,X,F10.6,X,F10.6,3X,F10.6,X,F10.6,X,F10.6))
    4 FORMAT (20I4)
    6 FORMAT (21H0The sites tested are  /
     1 11H0 Seq. Mult5X1HX9X1HY9X1HZ3X13HSite symmetry )
    7 FORMAT(2I5,3F10.6,3XA8)
    8 FORMAT (4F10.5)
    9 FORMAT(/,40H Enter number of sites to test? <0> none)
   10 FORMAT(/,26H enter X,Y,Z for test site )
   11 FORMAT(I)
C
C  GET NUMBER OF SITES TO EVALUATE
      I = 0
      WRITE(6,9)
      READ(5,11) N3P
      IF ( N3P.LE.0 ) GO TO 109
      N3 = N3P
C
C  GET THE TEST SITES
      DO 108 IXP=1,N3P
      I = I+1
      WRITE(6,10)
      READ(5,8) (X(L,I),L=1,3)
      BISO = 1.0
      DO 381 L=4,9
  381 X(L,I) = 0.0
  105 CONTINUE
      DO 106 L=1,9
  106 Y(1,L)=X(L,I)
      CALL SYMOPR
      CALL SYMNUM(I)
      IXB(I) = KXB
C
C  WRITE ATOM PLACEMENTS
C     IZB( 1) = MOD(IXB(I)/512    ,8)
C     IZB( 2) = MOD(IXB(I)/64     ,8)
C     IZB( 3) = MOD(IXB(I)/8      ,8)
C     IZB( 4) = MOD(IXB(I)        ,8)
C     IZB( 5) = MOD(IXB(I)/4096   ,8)
C     IZB( 6) = MOD(IXB(I)/32768  ,2)
C     IZB( 7) = MOD(IXB(I)/65536  ,2)
C     IZB( 8) = MOD(IXB(I)/131072 ,4)
C     IZB( 9) = MOD(IXB(I)/524288 ,4)
C     IZB(10) = MOD(IXB(I)/2097152,16)
C     PRINT 1,I,XLT,IXB(I),IZB,((Y(L,N),N=1,3),NCTR(L),L=1,MULT)
C
      X(11,I) = XLT
      DXL = AMOD(X(1,I)-Y(1,1)+10.0,1.0)
      DYL = AMOD(X(2,I)-Y(1,2)+10.0,1.0)
      DZL = AMOD(X(3,I)-Y(1,3)+10.0,1.0)
      IF ( DXL+DYL+DZL.LT..00001 ) GO TO 104
      DO 107 L=1,9
  107 X(L,I) = Y(1,L)
  104 IF ( N12(I).LE.0 ) X(4,I)=BISO
C
C  REMOVE REDUNDANCIES DUE TO SITE MULTIPLICITY
200   IF( MULT .LE. 1 )GO TO 250
      DO 205 ITMP0=2,MULT
      DO 210 ITMP1=1,ITMP0-1
      IF( Y(ITMP1,1) .EQ. 100.0 )GO TO 210
      IF( ABS(Y(ITMP0,1)-Y(ITMP1,1)) .GT. 0.0001 )GO TO 210
      IF( ABS(Y(ITMP0,2)-Y(ITMP1,2)) .GT. 0.0001 )GO TO 210
      IF( ABS(Y(ITMP0,3)-Y(ITMP1,3)) .GT. 0.0001 )GO TO 210
      Y(ITMP1,1) = 100.0
210   CONTINUE
205   CONTINUE
      ITMP0 = 0
      DO 215 ITMP1=1,MULT
      IF( Y(ITMP1,1) .EQ. 100.0 )GO TO 215
      ITMP0 = ITMP0 + 1
      Y(ITMP0,1) = Y(ITMP1,1)
      Y(ITMP0,2) = Y(ITMP1,2)
      Y(ITMP0,3) = Y(ITMP1,3)
215   CONTINUE
      GO TO 255
250   ITMP0 = MULT
255   ITMP=X(11,I)*FLOAT(MULT)+0.001
*      WRITE(6,1) I,ITMP
*      WRITE(6,2)((Y(L,N),N=1,3),L=1,ITMP0)
  108 CONTINUE
C
C  PRINT THE RESULTS OF THE TEST SITE SYMMETRY
      WRITE(6,6)
      DO 1061 I=1,N3
      I4 = X(11,I)*FLOAT(MULT)+0.001
      ITAB = ISYM(I)
C     WRITE(6,7) I,I4,(X(L,I),L=1,3),TAB(ITAB),IXB(I),IXB(I),ITAB
      WRITE(6,7) I,I4,(X(L,I),L=1,3),TAB(ITAB)
 1061 CONTINUE
  109 CONTINUE
      RETURN
      END
      SUBROUTINE SYMOPR
C
      COMMON/CRYDAT/ N(2),L,X(192),Y(192),Z(192),B11(192),B22(192),
     1 B33(192),B12(192),B13(192),B23(192),XLT,KXB,NCTR(192)
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
C
      ISCK = 0
  103 L = 2
      ISRH = 0
      KXB = 0
      XLT = 1.0
      J = 1
      CALL CEL000
      L1=J
      DO 100 I=1,8
      IOP = 0
      IF ( NCONT(I).EQ.0 ) GO TO 104
    1 DO 99 L2=J,L1
      L3=L-1
      IF ( NCONT(I)-8192 ) 4,5,4
    5 X(L)=X(L2)+1.0/3.0
      Y(L)=Y(L2)+2.0/3.0
      Z(L)=Z(L2)+2.0/3.0
      X(L+1)=X(L2)+2.0/3.0
      Y(L+1)=Y(L2)+1.0/3.0
      Z(L+1)=Z(L2)+1.0/3.0
      B11(L)=B11(L2)
      B22(L)=B22(L2)
      B33(L)=B33(L2)
      B12(L)=B12(L2)
      B13(L)=B13(L2)
      B23(L)=B23(L2)
      B11(L+1)=B11(L2)
      B22(L+1)=B22(L2)
      B33(L+1)=B33(L2)
      B12(L+1)=B12(L2)
      B13(L+1)=B13(L2)
      B23(L+1)=B23(L2)
      L=L+1
      CALL CEL000
      L=L+1
      CALL CEL000
      GO TO 6
    4 CALL OPERTR(I,L2)
    6 L5=L
      L6=NCONT(I)
    7 L = L3+1
    8 L4 = 1
      IF ( ABS(X(L)-X(L4))-0.0001 ) 2,2,90
    2 IF ( ABS(Y(L)-Y(L4))-0.0001 ) 3,3,90
    3 IF ( ABS(Z(L)-Z(L4))-0.0001 ) 91,91,90
   91 CONTINUE
      IF ( NCTR(L)-8192 ) 92,94,93
   92 KX = MOD(NCTR(L),4)+1
      KY = MOD(NCTR(L)/16,4)+1
      KZ = MOD(NCTR(L)/256,2)
      IF ( IOP.EQ.0 ) XLT=XLT/2.0
      IOP = 1
      GO TO (920,930,940,950),KX
  920 GO TO (921,1000,922,1000),KY
  921 IF ( KZ.EQ.0 ) GO TO 1000
      KXB = IOR(KXB,2621450)
      GO TO 90
  922 CONTINUE
      IF ( KZ.EQ.0 ) KXB=IOR(KXB,2228292)
      IF ( KZ.EQ.1 ) KXB=IOR(KXB, 655432)
      GO TO 90
  930 KXB = IOR(KXB,32768)
      GO TO (1000,931,1000,932),KY
  931 CONTINUE
      IF ( KZ.EQ.0 ) KXB=IOR(KXB, 4194464)
      IF ( KZ.EQ.1 ) KXB=IOR(KXB,12583048)
      GO TO 90
  932 KXB = IOR(KXB,2753088)
      IF ( KZ.EQ.1 ) KXB = IOR(KXB,8)
      GO TO 90
  940 KXB = IOR(KXB,512)
      GO TO (941,1000,942,1000),KY
  941 KXB = IOR(KXB,131072)
      IF ( KZ.EQ.1 ) GO TO 943
      KXB = IOR(KXB,525312)
      GO TO 90
  942 KXB = IOR(KXB,64)
      IF ( KZ.EQ.1 ) GO TO 944
      KXB = IOR(KXB,2623488)
      GO TO 90
  943 KXB = IOR(KXB,2097152)
  944 KXB = IOR(KXB,8)
      GO TO 90
  950 KXB = IOR(KXB,32768)
      GO TO (1000,951,1000,952),KY
  951 KXB = IOR(KXB,2753088)
      IF ( KZ.EQ.1 ) KXB = IOR(KXB,8)
      GO TO 90
  952 IF ( KZ.EQ.0 ) KXB = IOR(KXB,8388864)
      IF ( KZ.EQ.1 ) KXB=IOR(KXB,4194568)
      GO TO 90
   93 CONTINUE
      IF ( MOD(NCTR(L),16384).EQ.0 ) GO TO 95
      ISRH = 1
      IF ( IAND(307,NCTR(L)-NCONT(I)).EQ.0 ) GO TO 92
      GO TO 90
   94 KXB = IOR(KXB,2916928)
      XLT = XLT/3.0
      GO TO 99
   95 KXB = IOR(KXB,17924240)
      XLT = XLT/3.0
      GO TO 99
   90 CONTINUE
      IF ( L6-8192 ) 99, 98,98
   98 L6=1
      L = L+1
       GO TO 8
   99 L=L5
  100 L1=L-1
  104 CONTINUE
      IF ( ISRH.EQ.0 ) GO TO 200
      IF ( ISCK.GT.1 ) GO TO 2000
      ISCK = ISCK+1
      DO 1010 J=1,I
      IF ( NCONT(J).EQ.16384 ) GO TO 1011
 1010 CONTINUE
      DO 101 L2 = 1,L1
      IF ( ABS(X(L2)-Y(L2)).LE.0.0001 ) GO TO 102
      IF ( ABS(X(L2)+Y(L2)-1.0).LE.0.0002 ) GO TO 102
  101 CONTINUE
      ISCK = 2
      WRITE(6,110) X(1),Y(1),Z(1),XLT
      GO TO 200
 1011 CONTINUE
      WRITE(6,111) X(1),Y(1),Z(1),Y(1),Z(1),X(1)
      IF ( ABS(X(1)-Y(1)).LT.0.0001 ) GO TO 120
      X3 = X(1)
      X(1) = Y(1)
      Y(1) = Z(1)
      Z(1) = X3
      X3 = B11(1)
      B11(1) = B22(1)
      B22(1) = B33(1)
      B33(1) = X3
      GO TO 103
  110 FORMAT (37H0No X,X,Z or X,-X,Z set was found for4F8.5)
  102 IF ( L2.EQ.1 ) GO TO 120
      WRITE(6,111) X(1),Y(1),Z(1),X(L2),Y(L2),Z(L2)
  111 FORMAT (12H0The atom at 3F8.5,11H was put at3F8.5)
      X(1) = X(L2)
      Y(1) = Y(L2)
      Z(1) =Z(L2)
      B11(1) = B11(L2)
      B22(1) = B22(L2)
      B33(1) = B33(L2)
      B12(1) = B12(L2)
      B13(1) = B13(L2)
      B23(1) = B23(L2)
      GO TO 103
 1000 WRITE(6,112) NCTR(L)
  112 FORMAT (22H0The symmetry operator I10,9H is wrong)
      STOP 7701
 2000 CONTINUE
      WRITE(6,113) X(1),Y(1),Z(1)
  113 FORMAT (55H0There are unresolvable problems with the position set
     1 3F8.5/59H  Attempts to define the true site symmetry were abandon
     2ed.)
  120 IF ( ABS(X(1)-Y(1))+ABS(X(1)-Z(1)).LE.0.0002 ) GO TO 200
      DO 130 L2=2,L1
      IF ( ABS(X(L2)-Y(L2))+ABS(X(L2)-Z(L2)).LE.0.0002 ) GO TO 102
  130 CONTINUE
  200 CONTINUE
      KXB = MAX0(IAND(KXB,18874367),IAND(KXB,16777215))
      IF ( IAND(KXB,384).EQ.384 ) KXB=IOR(KXB,512)
      RETURN
      END

      SUBROUTINE CEL000
C
      COMMON/CRYDAT/ N(2),L,X(192),Y(192),Z(192),B11(192),B22(192),
     1 B33(192),B12(192),B13(192),B23(192),XLT,KXB,NCTR(192)
C
      X(L-1) = AMOD(X(L-1)+8.0,1.0)
      IF ( X(L-1)-.99999 ) 2,1,1
    1 X(L-1) = 0.0
    2 Y(L-1) = AMOD(Y(L-1)+8.0,1.0)
      IF ( Y(L-1)-.99999 ) 4,3,3
    3 Y(L-1) = 0.0
    4 Z(L-1) = AMOD(Z(L-1)+8.0,1.0)
      IF ( Z(L-1)-.99999 ) 6,5,5
    5 Z(L-1) = 0.0
    6 RETURN
      END

      SUBROUTINE OPERTR(I,L2)
C
      COMMON/CRYDAT/ N(2),L,X(192),Y(192),Z(192),B11(192),B22(192),
     1 B33(192),B12(192),B13(192),B23(192),XLT,KXB,NCTR(192)
      COMMON/SPG/ SPGC(20),NSP(2),NCONT(10),NC,NPOL,MULT
C
      I1 = MOD(NCONT(I),4)+1
      I2 = MOD(NCONT(I)/4,4)+1
      I3 = MOD(NCONT(I)/16,4)+1
      I4 = MOD(NCONT(I)/64,4)+1
      I5 = MOD(NCONT(I)/256,2)
      I6 = MOD(NCONT(I)/512,4)+1
      I7 = MOD(NCONT(I)/2048,4)+1
      I8 = NCONT(I)/8192+1
      GO TO (100,200,300),I8
  100 GO TO (101,102,103,104),I1
  101 X(L) = X(L2)
      GO TO 1030
  102 X(L) = Y(L2)
      GO TO 1040
  103 X(L) = -X(L2)
 1030 B11(L) = B11(L2)
      B13(L) = B13(L2)*(ABS(FLOAT(I1+I5)-2.5)-1.0)*2.0
      GO TO 105
  104 X(L) = -Y(L2)
 1040 B11(L) = B22(L2)
      B13(L) = B23(L2)*(ABS(FLOAT(I1+I5)-3.5)-1.0)*2.0
  105 GO TO (110,107,108,106),I2
  106 X(L) = X(L)+0.25
  107 X(L) = X(L)+0.25
  108 X(L) = X(L)+0.25
  110 GO TO (111,112,113,114),I3
  111 Y(L) = Y(L2)
      GO TO 1130
  112 Y(L) = X(L2)
      GO TO 1140
  113 Y(L) = -Y(L2)
 1130 B22(L) = B22(L2)
      B12(L) = B12(L2)*FLOAT(MOD(I1+I3,4)-1)
      B23(L) = B23(L2)*(ABS(FLOAT(I3+I5)-2.5)-1.0)*2.0
      GO TO 115
  114 Y(L) = -X(L2)
 1140 B22(L) = B11(L2)
      B23(L) = B13(L2)*(ABS(FLOAT(I3+I5)-3.5)-1.0)*2.0
      B12(L) = B12(L2)*FLOAT(MOD(I1+I3-2,4)-1)
  115 GO TO (120,117,118,116),I4
  116 Y(L) = Y(L)+0.25
  117 Y(L) = Y(L)+0.25
  118 Y(L) = Y(L)+0.25
  120 Z(L) = Z(L2)*FLOAT(1-2*I5)
      B33(L) = B33(L2)
      GO TO (125,122,123,121),I6
  121 Z(L) = Z(L)+0.25
  122 Z(L) = Z(L)+0.25
  123 Z(L) = Z(L)+0.25
  125 GO TO (130,127,126),I7
  126 Z(L) = Z(L)+0.333333333
  127 Z(L) = Z(L)+0.333333333
  130 L = L+1
      CALL CEL000
      RETURN
  200 X(L) = -Y(L2)
      Y(L) = X(L2)-Y(L2)
      Z(L) = Z(L2)+0.333333333*FLOAT(I2-2)
*      B11(L) = B22(L2)
      B22(L) = B11(L2)+B22(L2)-B12(L2)
      B33(L) = B33(L2)
      B12(L) = 2.0*B22(L2 )-B12(L2 )
      B13(L) = -B23(L2)
      B23(L) = B13(L2)-B23(L2)
      L = L+1
      CALL CEL000
      X(L) = -Y(L-1)
      Y(L) = -X(L2)
      Z(L) = Z(L2)-0.333333333*FLOAT(I2-2)
      B11(L) = B22(L-1)
      B22(L) = B11(L-1)+B22(L-1)-B12(L-1)
      B33(L) = B33(L-1)
      B12(L) = 2.0*B22(L-1)-B12(L-1)
      B13(L) = -B23(L-1)
      B23(L) = B13(L-1)-B23(L-1)
      GO TO 130
  300 I1 = L2
  301 X(L) = Z(I1)
      Y(L) = X(I1)
      Z(L) = Y(I1)
      B11(L) = B33(I1)
      B22(L) = B11(I1)
      B33(L) = B22(I1)
      B12(L) = B13(I1)
      B13(L) = B23(I1)
      B23(L) = B12(I1)
      IF ( I1-L2 ) 302,302,130
  302 I1 = L
      L = L+1
      CALL CEL000
      GO TO 301
      END

      SUBROUTINE SYMNUM(J)
C
      REAL*8 TAB
      COMMON /SYML/ ISYM(100)
      COMMON/CRYDAT/ NNMAX(3),Y(192,9),XLT,KXB,NCTR(192)
      COMMON /SYMTAB/TAB(62)
      DIMENSION K(62)
      DATA TAB/8H 1      ,8H 1BAR   ,8H 1 2 1  ,8H 2 1 1  ,8H 1 1 2  ,
     18H M 1 1  ,8H 1 1 M  ,8H 1 M 1  ,8H 1 2/M 1,8H 2/M 1 1,8H 1 1 2/M,
     28H 2 2 2  ,8H 2 M M  ,8H M 2 M  ,8H M M 2  ,8H M M M  ,8H 3BAR   ,
     38H 3 2    ,8H MMM(+-),8H 4BAR   ,8H 3      ,8H 2(-)   ,8H 2 3    ,
     48H 6/M    ,8H 6 2    ,8H 3 1 2  ,8H 6BAR   ,8H 6      ,8H 222(+-),
     58H 3      ,8H 2(+)   ,8H 6 2    ,8H 4B M 2 ,8H 2/M(+) ,8H M(+)   ,
     68H M(-)   ,8H MM2(+-),8H 4      ,8H 4B 2 M ,8H 4/M M M,8H 4 M M  ,
     78H 4 2 2  ,8H 4/M    ,8H 2/M(-) ,8H 3B M 1 ,8H 3 M 1  ,8H 3B 1 M ,
     88H 3 1 M  ,8H 3 2 1  ,8H 6/M M M,8H 6 M M  ,8H 6B M 2 ,8H 6B 2 M ,
     98H 3BAR   ,8H M 3 M  ,8H 4 3 2  ,8H 3 M    ,8H 3B M   ,8H M 3    ,
     A8H M2M(+) ,8H M2M(-) ,8H 4B 3 M /
      DATA K/ 0,     584, 2228744,  655432, 2624064,  656896, 2621450,
     1  2228292, 2228812,  656968, 2624074, 2755144, 2752590, 2754058,
     2  2756164, 2756174,17924824,17925016,15240170, 2787912,17924240,
     3  4227336,18582232, 2918986,15502280, 7111496, 2916938, 2918976,
     4 15240136, 2916928,12615816, 2919368,15372236,12616648, 4227232,
     5  8421632,15240160, 2787904,15371240,15372270,15372260,15371208,
     6  2787914, 4228072,15500232,11305792, 7111656, 7111392,15499976,
     7 15502314,15502304,15500106,15500010, 2916936,18583550,18582488,
     8 17924272,17925112,18583262,15237290,
     9 15237386,18582520/
C
      DO 100 I=1,62
      IF ( KXB.EQ.K(I) ) GO TO 110
  100 CONTINUE
      I = 65
  110 CONTINUE
      ISYM(J) = I
      RETURN
      END
